﻿
Public Class formSocketServidor

    Dim WithEvents socketServidor As New ClaseServidorSocket()

    'Iniciar el servidor, establecer el modo escucha
    'para recibir conexión de clientes
    Private Sub btEscuchar_Click(sender As System.Object,
               e As System.EventArgs) Handles btEscuchar.Click
        If txtPuerto.Text <> "" Then
            Try
                socketServidor.Puerto = txtPuerto.Text
                socketServidor.IniciarEscucha()
                btEscuchar.Enabled = False
                txtPuerto.Enabled = False
                txtMensaje.Enabled = True
                btEnviarMensaje.Enabled = True
                btDetenerEscucha.Enabled = True
                txtMensaje.Focus()
            Catch err As Exception
                MsgBox("Se ha producido un error al intentar " & _
                       "establecer escucha por el puerto " & _
                   txtPuerto.Text & vbCrLf & vbCrLf & err.Message,
                   MsgBoxStyle.Critical + MsgBoxStyle.OkOnly)
            End Try
        Else
            MsgBox("Debe indicar el puerto por el que establecer la escucha.",
                    MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
            txtPuerto.Focus()
        End If
    End Sub


    'Evento que se ejecutará cuando un nuevo cliente se conecte
    Private Sub socketServidor_NuevaConexion(ByVal IDTerminal As  _
                 System.Net.IPEndPoint) Handles socketServidor.NuevaConexion
        txtLog.Text = txtLog.Text & vbCrLf & "Conectado cliente: " &
            IDTerminal.Address.ToString & ", Puerto: " & IDTerminal.Port
    End Sub


    'Evento que se ejecutará cuando finalice la conexión de un cliente
    Private Sub socketServidor_ConexionTerminada(ByVal IDTerminal As  _
                 System.Net.IPEndPoint) Handles socketServidor.ConexionTerminada
        txtLog.Text = txtLog.Text & vbCrLf & "Desconectado cliente: " &
            IDTerminal.Address.ToString & ", Puerto: " & IDTerminal.Port
        btEscuchar.Enabled = True
        txtPuerto.Enabled = True
    End Sub

    'Evento que se ejecutará cuando se reciban datos de los clientes conectados
    Private Sub socketServidor_DatosRecibidos(ByVal IDTerminal As  _
               System.Net.IPEndPoint) Handles socketServidor.DatosRecibidos
        'Datos del cliente que se conecta
        txtLog.Text = txtLog.Text & vbCrLf &
            "Cliente: " & IDTerminal.Address.ToString &
            ", Puerto: " & IDTerminal.Port

        'Mensaje recibido del cliente
        txtMensajeRecibido.Text = IDTerminal.Address.ToString & " " & Now & " " &
            txtMensajeRecibido.Text & " " & socketServidor.ObtenerDatos(IDTerminal)
    End Sub

    'Enviar mensaje a todos los clientes conectados
    Private Sub btEnviarMensaje_Click(sender As System.Object,
              e As System.EventArgs) Handles btEnviarMensaje.Click
        socketServidor.enviarMensajeTodosClientes(txtMensaje.Text)
    End Sub

    'Detener modo escucha, no se recibirán conexiones de clientes
    Private Sub btDetenerEscucha_Click(sender As System.Object,
              e As System.EventArgs) Handles btDetenerEscucha.Click
        btEscuchar.Enabled = True
        txtPuerto.Enabled = True
        txtMensaje.Enabled = False
        btEnviarMensaje.Enabled = False
        btDetenerEscucha.Enabled = False
        Try
            socketServidor.DetenerEscucha()
        Catch err As Exception
            MsgBox("Error al detener la escucha:" + vbCrLf +
                   vbCrLf + err.Message,
                   MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
        End Try
    End Sub

    'Finalizamos con End para cerrar el hilo (thread) abierto 
    Private Sub formSocketServidor_FormClosed(sender As System.Object,
               e As System.Windows.Forms.FormClosedEventArgs) _
               Handles MyBase.FormClosed
        End
    End Sub
End Class
